#include "Vertor_MEGA.h"

Vertor_MEGA::Vertor_MEGA() {
    
}

Vertor_MEGA::~Vertor_MEGA() {
    if (this->I2C_client)
        delete this->I2C_client;
}

void Vertor_MEGA::init() {
    this->I2C_client = new I2C();
    I2CTransport::setClient(this->I2C_client);
    I2CTransport::begin();
    /* Config pins for motors */
    for (uint8_t i = 0; i < 6; i++) {
        pinMode(this->motorPins[i].control_1, OUTPUT);
        pinMode(this->motorPins[i].control_2, OUTPUT);
        pinMode(this->motorPins[i].pwm, OUTPUT);
        digitalWrite(this->motorPins[i].control_1, LOW);
        digitalWrite(this->motorPins[i].control_2, LOW);
        digitalWrite(this->motorPins[i].pwm, LOW);
    }
}

void Vertor_MEGA::writeServo(uint8_t servoID, uint16_t angle) {
    if (servoID > 11)
        return;
        
    STM8_I2C::setPWM(servoID, angle);
}

void Vertor_MEGA::writeDCMotor(uint8_t motorID, uint8_t pwm, uint8_t reverse) {
    if (motorID < 1 || motorID > 6)
        return;

    if (reverse) {
        /* Backward */
        digitalWrite(this->motorPins[motorID - 1].control_1, 0);
        digitalWrite(this->motorPins[motorID - 1].control_2, 1);
        /* Value */
        analogWrite(this->motorPins[motorID - 1].pwm, pwm);
    } else {
        /* Forward */
        digitalWrite(this->motorPins[motorID - 1].control_1, 1);
        digitalWrite(this->motorPins[motorID - 1].control_2, 0);
        /* Value */
        analogWrite(this->motorPins[motorID - 1].pwm, pwm);
    }
}
