#ifndef VERTOR_MEGA_H
#define VERTOR_MEGA_H

#include <Arduino.h>
#include <STM8_I2C.h>
#include "BoardExternalEnvironment.h"

struct motorPins_t {
    uint8_t control_1;
    uint8_t control_2;
    uint8_t pwm;
};

class Vertor_MEGA : public BoardExternalEnvironment {
    public:
        Vertor_MEGA();
        ~Vertor_MEGA();
        void init();
        void writeServo(uint8_t servoID, uint16_t angle);
        void writeDCMotor(uint8_t motorID, uint8_t pwm, uint8_t reverse);

    private:
        I2C *I2C_client = nullptr;
        const motorPins_t motorPins[6] = {
            {24, 25, 2},   /* Motor 1 */
            {22, 23, 5},   /* Motor 2 */
            {28, 29, 7},   /* Motor 3 */
            {26, 27, 6},   /* Motor 4 */
            {35, 34, 45},  /* Motor 5 */
            {37, 36, 46}   /* Motor 6 */
        };
};

#endif /* VERTOR_MEGA_H */
