#ifndef VERTOR_PCA_H
#define VERTOR_PCA_H

#include <Arduino.h>
#include <I2CTransport.h>
#include <PCA9685.h>
#include "BoardExternalEnvironment.h"

class Vertor_PCA : public BoardExternalEnvironment {
    public:
        Vertor_PCA() {}
        ~Vertor_PCA();
        void init();
        /* Servo */
        void setRangeUs(uint16_t min, uint16_t max);
        void writeServo(uint8_t servoID, uint16_t angle);
        /* DCMotor */
        void writeDCMotor(uint8_t motorID, uint8_t pwm, uint8_t reverse);

    private:
        I2C *clientI2C = nullptr;
        uint16_t min_us = SERVO_DEFAULT_MIN;
        uint16_t max_us = SERVO_DEFAULT_MAX;
};

#endif /* VERTOR_PCA_H */