#include "Vertor_STM.h"

Vertor_STM::Vertor_STM() {

}

Vertor_STM::~Vertor_STM() {
    if (this->clientI2C)
        delete this->clientI2C;
}

void Vertor_STM::init() {
    this->clientI2C = new I2C();
    I2CTransport::setClient(this->clientI2C);
    I2CTransport::begin();
}

void Vertor_STM::writeServo(uint8_t servoID, uint16_t angle) {
    if (servoID > 7)
        return;

    STM8_I2C_standart::setPWM(7 - servoID, angle);
}

void Vertor_STM::writeDCMotor(uint8_t motorID, uint8_t pwm, uint8_t reverse) {
    if (motorID > 3)
        return;

    if (reverse) {
        STM8_I2C_standart::setPWM(2*motorID + 8, 255 - pwm);
        STM8_I2C_standart::setPWM(2*motorID + 9, 255);
    } else {
        STM8_I2C_standart::setPWM(2*motorID + 8, pwm);
        STM8_I2C_standart::setPWM(2*motorID + 9, 0);
    }
}