#include <Wire.h>
#include <I2C.h>
#include <I2CTransport.h>
#include <PCA9685.h>
#include <DualWheelTruck.h>

// Инициализация альтернативного I2C протокола
I2C myI2C = I2C();

// Инициализация транспортной утилиты I2C
// Она нужна чтобы иметь возможность абстрагироваться
// от конкретной библиотеки - I2C или Wire
I2CTransport transport = I2CTransport();

// Инициализация ШИМ контроллера
PCA9685* pwmController = new PCA9685(0x40);

// Создание объекта - мотор
DCMotor motor = DCMotor(pwmController, 0, 1, 20, true, 3);

void setup() {
	// Установка i2c клиента в транспортную утилиту и запуск I2C
	I2CTransport::setClient(&myI2C);
	I2CTransport::begin();

	pwmController->begin();

	// Инициализация serial
	Serial.begin(9600);

	//Ждем 3 секунды перед началом работы
	Chronos::delay(3000);
}

void loop() {
	Serial.println("\nStart forward");
	motor.forward(100);
	Chronos::delay(2000);
	Serial.println("\nStart backward");
	motor.backward(100);
	Chronos::delay(2000);
}
