#ifndef _GEEGROW_2WD_SPEED_REGULTOR_H
#define _GEEGROW_2WD_SPEED_REGULTOR_H
#include <Arduino.h>
#include "PidRegulator.h"
#include "DCMotor.h"

#define MIN_CORRECTION_LIMIT -100
#define MAX_CORRECTION_LIMIT 100

class DualWheelSpeedRegulator {
	public:

		DualWheelSpeedRegulator();

		void attachLeftMotor(DCMotor* motor);
		void attachRightMotor(DCMotor* motor);
		void attachLeftEncoder(OpticalTickEncoder* encoder);
        void attachRightEncoder(OpticalTickEncoder* encoder);
        void attachLeftEncoder(HallTickEncoder* encoder);
		void attachRightEncoder(HallTickEncoder* encoder);
        void attachLeftEncoder(BaseTickEncoder* encoder);
        void attachRightEncoder(BaseTickEncoder* encoder);
		void setSpeed(int8_t speed);
		void setPidFactors(float Kp, float Ki, float Kd);
		void reset();
		void setDebugMode(char mode);
        void throttlingOn();
        void throttlingOff();
		void run();

	private:

		// Motors
		DCMotor* leftMotor;
		DCMotor* rightMotor;

		// Encoders
		BaseTickEncoder* leftEncoder;
		BaseTickEncoder* rightEncoder;

		PidRegulator* pidRegulator;

        int8_t throttlingStep = 0;
        bool throttlingMode = false;

		int8_t speed = 0;
};

#endif
