#include "HallTickEncoder.h"

HallTickEncoder::HallTickEncoder(uint8_t _ch1, uint8_t _ch2, uint16_t _pulsesPerLoop) : BaseTickEncoder(_pulsesPerLoop) {
    this->ch1 = _ch1;
    this->ch2 = _ch2;
    pinMode(this->ch1, INPUT);
    pinMode(this->ch2, INPUT);
}

void HallTickEncoder::update() {
    if (!this->isEnabled)
        return;

    uint8_t ch1_stateNew = digitalRead(this->ch1);
    uint8_t ch2_stateNew = digitalRead(this->ch2);
    this->ticksPerPulseCounter++;

    /* Try to detect leading edge */
    if (this->ch1_statePrev == LOW && ch1_stateNew == HIGH) {
        // if (ch2_stateNew == HIGH) {
        //     /* CW */
        //     this->_isCCW = false;
        // } else {
        //     /* CCW */
        //     this->_isCCW = true;
        // }

        this->ticksPerPulse = this->ticksPerPulseCounter;
        this->ticksPerPulseCounter = 0;
        this->pulsesTravelled++;
        this->isForward ? (this->pulsesCounter++) : (this->pulsesCounter--);

        if (this->pulsesLimit > 0 && this->isLimited()) {
            this->pulsesLimit--;
        }
    }

    this->ch1_statePrev = ch1_stateNew;
    this->ch2_statePrev = ch2_stateNew;
}