#include "OpticalTickEncoder.h"

OpticalTickEncoder::OpticalTickEncoder(uint8_t _ch, uint16_t _pulsesPerLoop) : BaseTickEncoder(_pulsesPerLoop) {
    this->ch = _ch;
    pinMode(this->ch, INPUT);
}

void OpticalTickEncoder::update() {
    if (!this->isEnabled)
        return;

    uint8_t ch_stateNew = digitalRead(this->ch);
    this->ticksPerPulseCounter++;

    if (ch_stateNew != this->ch_statePrev) {
        this->ticksPerPulse = this->ticksPerPulseCounter;
        this->ticksPerPulseCounter = 0;

        this->pulsesTravelled++;

        this->isForward ? (this->pulsesCounter++) : (this->pulsesCounter--);

        if (this->pulsesLimit > 0 && this->isLimited())
            this->pulsesLimit--;
    }

    this->ch_statePrev = ch_stateNew;
}