#ifndef _GEEGROW_PID_REGULTOR_H
#define _GEEGROW_PID_REGULTOR_H
#include <Arduino.h>

class PidRegulator {
	public:
		
		PidRegulator();
		PidRegulator(float Kp, float Ki, float Kd);
		void setResultLimits(int16_t min, int16_t max);
		void resetLimits();
		// void setPeriod(uint8_t periodMs);
		void setPidFactors(float Kp, float Ki, float Kd);
		void reset();
		void setDebugMode(char mode);
		int16_t run(int16_t left, int16_t right);
		
	private:

		/*
		* +--------------------------------------------------------------+
		* | 0 | silent mode                                              |
		* |---+----------------------------------------------------------|
		* | 1 | text output                                              |
		* |---+----------------------------------------------------------|
		* | 2 | print E for visual debug with arduino Serial Plotter     |
		* |---+----------------------------------------------------------|
		* | 3 | print P for visual debug with arduino Serial Plotter     |
		* |---+----------------------------------------------------------|
		* | 4 | print I for visual debug with arduino Serial Plotter     |
		* |---+----------------------------------------------------------|
		* | 5 | print D for visual debug with arduino Serial Plotter     |
		* |---+----------------------------------------------------------|
		* | 6 | print P,I,D for visual debug with arduino Serial Plotter |
		* |---+----------------------------------------------------------|
		*/
		char debugMode = 0;
		bool firstRun = true;

		float Kp = 30;		// Bigger value will give faster results;
		float Ki = 0.05;	// Big values can made system unstable;
		float Kd = 1;		// Big values can give made system nervous;

		float I = 0;

		int16_t previousDifference = 0;

		bool useLimits = false;
		int16_t minLimit = 0;
		int16_t maxLimit = 0;
		
		void debugPlot(int16_t E, float P, float I, float D);

		#define debugPrint(...)    if (debugMode == 1) { Serial.print(__VA_ARGS__); }
        #define debugPrintln(...)  if (debugMode == 1) { Serial.println(__VA_ARGS__); }
};

#endif