#ifndef STM8_I2C_H
#define STM8_I2C_H

#include <Arduino.h>
#include <I2CTransport.h>
#include <Tweak.h>


#define STM8_I2C_ADDR   16
#define I2C_BUFFER_SIZE 16

/* BotPilot */
#define I2C_READY_PORT          PINE
#define I2C_READY_CONF_IO       DDRE
#define I2C_READY_CONF_PULL     PORTE
#define I2C_READY_PIN           PE2

class STM8_I2C : TweakCallbackOwnerClass {
    public:
        static STM8_I2C& me() {
            static STM8_I2C instance;
            return instance;
        }

        static void setPWM(uint8_t pin, uint8_t value);
        static void setPWM(uint8_t* data);

        void tweakHandler();

    private:
        STM8_I2C();
        ~STM8_I2C() {}
        STM8_I2C(const STM8_I2C&) = delete;
        STM8_I2C& operator = (STM8_I2C&) = delete;

        bool is_I2C_ready();
        void update();

        uint8_t buf[I2C_BUFFER_SIZE] = {0};
        uint8_t tweakID = 0;
        bool gotNew = false;
};

#endif /* STM8_I2C_H */