#include "STM8_I2C_standart.h"

STM8_I2C_standart::STM8_I2C_standart() {
    /* Config control i2c pin */
    I2C_READY_CONF_IO &= ~(1 << I2C_READY_PIN);   // set as input
    I2C_READY_CONF_PULL |= (1 << I2C_READY_PIN);   // set pull-up

    this->tweakID = Tweak::attachMsMemberCallback(this, 1);
    Tweak::setCallbackActive(this->tweakID, false);
}

void STM8_I2C_standart::setPWM(uint8_t pin, uint8_t value) {
    me().buf[pin] = value;

    me().gotNew = true;
    Tweak::setCallbackActive(me().tweakID, true);
}

void STM8_I2C_standart::setPWM(uint8_t* data) {
    for (uint8_t i = 0; i < I2C_BUFFER_SIZE; i++) {
        me().buf[i] = data[i];
    }

    me().gotNew = true;
    Tweak::setCallbackActive(me().tweakID, true);
}

void STM8_I2C_standart::update() {
    if (me().gotNew) {
        if (!me().is_I2C_ready())
            return;

        I2CTransport::writeBytes(
            STM8_I2C_standart_ADDR,
            I2C_BUFFER_SIZE,
            me().buf,
            false
        );
        me().gotNew = false;
        Tweak::setCallbackActive(me().tweakID, false);
    }
}

bool STM8_I2C_standart::is_I2C_ready() {
    return (I2C_READY_PORT & (1 << I2C_READY_PIN));
}

void STM8_I2C_standart::tweakHandler() {
    me().update();
}
