#ifndef STM8_I2C_STANDART_H
#define STM8_I2C_STANDART_H

#include <Arduino.h>
#include <I2CTransport.h>
#include <Tweak.h>


#define STM8_I2C_standart_ADDR   16
#define I2C_BUFFER_SIZE 16

/* Vertor_STM */
#define I2C_READY_PORT          PINF
#define I2C_READY_CONF_IO       DDRF
#define I2C_READY_CONF_PULL     PORTF
#define I2C_READY_PIN           PF0

class STM8_I2C_standart : TweakCallbackOwnerClass {
    public:
        static STM8_I2C_standart& me() {
            static STM8_I2C_standart instance;
            return instance;
        }

        static void setPWM(uint8_t pin, uint8_t value);
        static void setPWM(uint8_t* data);

        void tweakHandler();

    private:
        STM8_I2C_standart();
        ~STM8_I2C_standart() {}
        STM8_I2C_standart(const STM8_I2C_standart&) = delete;
        STM8_I2C_standart& operator = (STM8_I2C_standart&) = delete;

        bool is_I2C_ready();
        void update();

        uint8_t buf[I2C_BUFFER_SIZE] = {0};
        uint8_t tweakID = 0;
        bool gotNew = false;
};

#endif /* STM8_I2C_STANDART_H */